//***************************************************************************
//
//  ̧......: LCD_Driver.h
//  ......: ATMEL Norway
//  Ώ......: ATmega169
//  e......: LCD_Driver.cp̒`Ɛ錾
//  Ŕԍ....: 1.0
//
//  N   - VER. - 											- 
//  20020606 - 0.10 - ٍ̧쐬										- RM
//  20021010 - 1.0  - 											- JLL
//
//***************************************************************************


/* 萔` */

#define LCD_INITIAL_CONTRAST    0x0F						// ׽Ēl
#define LCD_TIMER_SEED		    3							// ۰ّx
#define LCD_FLASH_SEED          10							// _őx
#define LCD_REGISTER_COUNT      20							// ް ڼ޽
#define TEXTBUFFER_SIZE         25							// ޯ̧e

#define SCROLLMODE_ONCE         0x01						// 1۰َwԍ(gp)
#define SCROLLMODE_LOOP         0x02						// A۰َwԍ(gp)
#define SCROLLMODE_WAVE         0x03						// /tA۰َwԍ(gp)

/* ϸے` */

#define LCD_SET_COLON(active) LCD_Data[8] = active			// ATmega169Lް`(active=[TRUE|FALSE])
#define pLCDREG ((unsigned char *)(0xEC))					// ATmega169ް ڼ޽ʒu`
#define LCD_CONTRAST_LEVEL(level) LCDCCR=(0x0F & level)		// ATmega169׽Đʒu`

/* ϐ` */

extern char gLCD_Update_Required;							// LCD\XVv׸
extern char LCD_Data[LCD_REGISTER_COUNT];					// LCDDRޯ̧(ޯ̧LCDDRޯ̧LCDDR)
extern char gTextBuffer[TEXTBUFFER_SIZE];					// ޯ̧(: ޯ7=_Ŏw)
extern char gScrollMode;									// ۰ON/OFF׸
extern char gFlashTimer;									// _Ŏvl
extern char gColon;											// (:)\ON/OFF׸
extern signed char gScroll;									// ۰ٗp\Jnʒu(-6`+25)

/* ֐錾 */

void LCD_Init (void);										// LCDݒLCD\ޯ̧
void LCD_WriteDigit(char input, char digit);				// LCDDRޯ̧ɑΉ ްݒ
void LCD_AllSegments(char show);							// S_܂͑SLCDDRޯ̧
