/* ŏIXV: RM 2001N117 20:15 */

//*****************************************************************************
//
//      COPYRIGHT (c) ATMEL Norway, 1996-2001
//
// ̎̒쌠ٳATMEL NorwayL܂B
//
// {ATMEL Norway̋܂́A񋟂ꂽ/_ŋK肳ꂽ
// ɏ]āAgp╡ʂł܂B
//
//*****************************************************************************
//
//  ̧......: DATAFLASH.C
//  ......: ATMEL Norway
//  Ώ......: SPIt̑SAVR
//  e......: ATMEL AT45Dxxx DataFlashذ p֐ (512`64MޯĎx)
//  Ŕԍ....:
//
//  N   - VER. - 											- 
//  20010117 - 1.00 - J										- RM
//  20010117 - 0.10 - ٍ̧쐬										- RM
//
//*****************************************************************************

#include <INA90.H>
#include "iom169.h"
#include "dataflash.h"

/* ߰ޗe,ڽ ޯĐ޲Ή\ */

flash unsigned char DF_pagebits[] ={9,9,9,9,9,10,10,11};						//߰ ڽ ޯĐ\(512k,1M,2M,4M,8M,16M,32M,64M)
flash unsigned int DF_pagesize[] ={264,264,264,264,264,528,528,1056};			//߰ޗeʕ\(512k,1M,2M,4M,8M,16M,32M,64M)

/* ϐ` */

unsigned char PageBits;															//߰ ڽ ޯĐ
unsigned int  PageSize;															//߰ޗe

//*****************************************************************************
//*
//*	֐	: DF_SPI_init
//*		: Ȃ
//*	߂l	: Ȃ
//*	ړI	: 3/Ͻʰ޳SPIݒ(:/SS/CSɎgp)
//*
//*****************************************************************************

void DF_SPI_init (void)
{
	PORTB |= (1<<PORTB3) | (1<<PORTB2) | (1<<PORTB1) | (1<<PORTB0);				// MOSI,SCK,/SS1wMISOٱߎw
	DDRB |= (1<<PORTB2) | (1<<PORTB1) | (1<<PORTB0);							// MISO,SCK,/SSo͐ݒ
	SPSR = (1<<SPI2X);															// {ݒ
	SPCR = (1<<SPE) | (1<<MSTR) | (1<<CPHA) | (1<<CPOL);						// 3Ͻ,2Ouݒ
}

//*****************************************************************************
//*
//*	֐	: DF_SPI_RW
//*		: SPIް ڼ޽֏ނׂ޲Ēl
//*	߂l	: SPIް ڼ޽̎M޲Ēl
//*	ړI	: SPIϽƂ1޲Ă̓ǂݏ
//*
//*****************************************************************************

unsigned char DF_SPI_RW (unsigned char output)
{
	unsigned char input;														// M޲Ēl

	SPDR = output;																// SPIް ڼ޽޲Ēl(output)ݒ
	while(!(SPSR & 0x80));														// ](SPIF=1)܂őҋ@
	input = SPDR;																// SPIް ڼ޽M޲Ēl擾
	return input;																// M޲ĒlƋɕA
}

//*****************************************************************************
//*
//*	֐	: Read_DF_status
//*		: Ȃ
//*	߂l	: ޲Ēl(XȂ镜ɂĂDataFlashްĂ𒲂ׂĂ)
//*	ړI	: DataFlashƒ/ҋ@Ɋւԏ
//*			  ޯ̧ׯ ߰ފԂ̔rɊւԏ
//*			  ޲̗eʂɊւԏ
//*
//*****************************************************************************

unsigned char Read_DF_status (void)
{
	unsigned char result,index_copy;											// ޲Ēl, ޲eʏޯĒl

	DF_CS_inactive;																// DataFlash̖ߕؾĂ邽߂
	DF_CS_active;																// CS̖˗LؑւɒӂĂB
	result = DF_SPI_RW(StatusReg);												// ڼ޽lǂ݂ݖߑM
	result = DF_SPI_RW(0x00);													// ʂ𓾂邽߂̋[
	index_copy = ((result & 0x38) >> 3);										// ڼ޽leʏ擾
	PageBits   = DF_pagebits[index_copy];										// Ή\߰ ڽ ޯĐ擾
	PageSize   = DF_pagesize[index_copy];										// Ή\߰ޗeʎ擾
	return result;																// ڼ޽lƋɕA
}

//*****************************************************************************
//*
//*	֐	: Page_To_Buffer
//*		: BufferNo	: ޯ̧1܂2̂ǂgp邩߂܂B
//*			  PageAdr	: ޯ̧֓]ׂ߰ ڽ
//*	߂l	: Ȃ
//*	ړI	: ׯ ؂DataFlashSRAMޯ̧߰ޓ]
//*
//*****************************************************************************

void Page_To_Buffer (unsigned int PageAdr, unsigned char BufferNo)
{
	DF_CS_inactive;																// DataFlash̖ߕؾĂ邽߂
	DF_CS_active;																// CS̖˗LؑւɒӂĂB
	if (1 == BufferNo)															/* ޯ̧1w莞 */
	{
		DF_SPI_RW(FlashToBuf1Transfer);											// ׯޯ̧1]ߕM
		DF_SPI_RW((unsigned char)(PageAdr >> (16 - PageBits)));					// ߰ ڽ޲ĒlM
		DF_SPI_RW((unsigned char)(PageAdr << (PageBits - 8)));					// ߰ ڽ޲ĒlM
		DF_SPI_RW(0x00);														// ߑ4޲ĒlM
	}
#ifdef USE_BUFFER2
	else	
	if (2 == BufferNo)															/* ޯ̧2w莞 */
	{
		DF_SPI_RW(FlashToBuf2Transfer);											// ׯޯ̧2]ߕM
		DF_SPI_RW((unsigned char)(PageAdr >> (16 - PageBits)));					// ߰ ڽ޲ĒlM
		DF_SPI_RW((unsigned char)(PageAdr << (PageBits - 8)));					// ߰ ڽ޲ĒlM
		DF_SPI_RW(0x00);														// ߑ4޲ĒlM
	}
#endif
	DF_CS_inactive;																// CS̖˗Lؑւœ]Jn
	DF_CS_active;
	while(!(Read_DF_status() & 0x80));											// ](RDY/BUSY=1)܂őҋ@
}

//*****************************************************************************
//*
//*	֐	: Buffer_Read_Byte
//*		: BufferNo	 : ޯ̧1܂2̂ǂgp邩߂܂B
//*			  IntPageAdr : ߰ޓڽ
//*	߂l	: 1޲Ă̓ǂ݂ݒl
//*	ړI	: DataFlashSRAMޯ̧1޲ēǂ݂
//*
//*****************************************************************************

unsigned char Buffer_Read_Byte (unsigned char BufferNo, unsigned int IntPageAdr)
{
	unsigned char data;															// ǂݍ(M)l

	DF_CS_inactive;																// DataFlash̖ߕؾĂ邽߂
	DF_CS_active;																// CS̖˗LؑւɒӂĂB
	if (1 == BufferNo)															/* ޯ̧1w莞 */
	{
		DF_SPI_RW(Buf1Read);													// ޯ̧1ǂ݂ݖߕM
		DF_SPI_RW(0x00);														// ߑ2޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr>>8));								// ߰ޓڽ޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr));									// ߰ޓڽ޲ĒlM
		DF_SPI_RW(0x00);														// ߑ5޲ĒlM
		data = DF_SPI_RW(0x00);													// ǂݍݒlM(擾)
	}
#ifdef USE_BUFFER2
	else
	if (2 == BufferNo)															/* ޯ̧2w莞 */
	{
		DF_SPI_RW(Buf2Read);													// ޯ̧2ǂ݂ݖߕM
		DF_SPI_RW(0x00);														// ߑ2޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr>>8));								// ߰ޓڽ޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr));									// ߰ޓڽ޲ĒlM
		DF_SPI_RW(0x00);														// ߑ5޲ĒlM
		data = DF_SPI_RW(0x00);													// ǂݍݒlM(擾)
	}
#endif
	return data;																// ǂݍ޲ĒlƋɕA
}

//*****************************************************************************
//*
//*	֐	: Buffer_Read_Str
//*		: BufferNo	  : ޯ̧1܂2̂ǂgp邩߂܂B
//*			  IntPageAdr  : ߰ޓڽ
//*			  No_of_bytes : ǂݍނׂ޲Đ
//*			  *BufferPtr  : ޲ēǂݍ݂Ɏgpׂޯ̧̐擪ڽ
//*	߂l	: Ȃ
//*	ړI	: DataFlashSRAMޯ̧*BufferPtrwޯ̧1܂͕޲ēǂ݂
//*
//*****************************************************************************

void Buffer_Read_Str (unsigned char BufferNo, unsigned int IntPageAdr, unsigned int No_of_bytes, unsigned char *BufferPtr)
{
	unsigned int i;

	DF_CS_inactive;																// DataFlash̖ߕؾĂ邽߂
	DF_CS_active;																// CS̖˗LؑւɒӂĂB
	if (1 == BufferNo)															/* ޯ̧1w莞 */
	{
		DF_SPI_RW(Buf1Read);													// ޯ̧1ǂ݂ݖߕM
		DF_SPI_RW(0x00);														// ߑ2޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr>>8));								// ߰ޓڽ޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr));									// ߰ޓڽ޲ĒlM
		DF_SPI_RW(0x00);														// ߑ5޲ĒlM
		for( i=0; i<No_of_bytes; i++)											/* (w޲Đ]) */
		{
			*(BufferPtr) = DF_SPI_RW(0x00);										// ǂݍݒlM(擾),AVRޯ̧ʒu֊i[
			BufferPtr++;														// ޯ̧ʒuis
		}
	}
#ifdef USE_BUFFER2
	else
	if (2 == BufferNo)															/* ޯ̧2w莞 */
	{
		DF_SPI_RW(Buf2Read);													// ޯ̧2ǂ݂ݖߕM
		DF_SPI_RW(0x00);														// ߑ2޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr>>8));								// ߰ޓڽ޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr));									// ߰ޓڽ޲ĒlM
		DF_SPI_RW(0x00);														// ߑ5޲ĒlM
		for( i=0; i<No_of_bytes; i++)											/* (w޲Đ]) */
		{
			*(BufferPtr) = DF_SPI_RW(0x00);										// ǂݍݒlM(擾),AVRޯ̧ʒu֊i[
			BufferPtr++;														// ޯ̧ʒuis
		}
	}
#endif
}
//: (IntAdr + No_of_bytes)<buffersizełȂ΂Ȃ炸AȂΔ͈͋Kŋtɑ܂B

//*****************************************************************************
//*
//*	֐	: Buffer_Write_Enable
//*		: BufferNo	 : ޯ̧1܂2̂ǂgp邩߂܂B
//*			  IntPageAdr : ߰ޓڽ
//*	߂l	: Ȃ
//*	ړI	: DataFlashSRAMޯ̧ւ̘A݋
//*			  : gp҂͑DataFlash@\ɐ旧Ė{I邽߂
//*				  CSHighɂ邱Ƃۏ؂Ȃ΂Ȃ܂B
//*
//*****************************************************************************

void Buffer_Write_Enable (unsigned char BufferNo, unsigned int IntPageAdr)
{
	DF_CS_inactive;																// DataFlash̖ߕؾĂ邽߂
	DF_CS_active;																// CS̖˗LؑւɒӂĂB
	if (1 == BufferNo)															/* ޯ̧1w莞 */
	{
		DF_SPI_RW(Buf1Write);													// ޯ̧1ݖߕM
		DF_SPI_RW(0x00);														// ߑ2޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr>>8));								// ߰ޓڽ޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr));									// ߰ޓڽ޲ĒlM
	}
#ifdef USE_BUFFER2
	else
	if (2 == BufferNo)															/* ޯ̧2w莞 */
	{
		DF_SPI_RW(Buf2Write);													// ޯ̧2ݖߕM
		DF_SPI_RW(0x00);														// ߑ2޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr>>8));								// ߰ޓڽ޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr));									// ߰ޓڽ޲ĒlM
	}
#endif
}

//*****************************************************************************
//*
//*	֐	: Buffer_Write_Byte
//*		: BufferNo	 : ޯ̧1܂2̂ǂgp邩߂܂B
//*			  IntPageAdr : ߰ޓڽ
//*			  Data		 : ނׂ޲Ēl
//*	߂l	: Ȃ
//*	ړI	: DataFlashSRAMޯ̧1޲ď
//*
//*****************************************************************************

void Buffer_Write_Byte (unsigned char BufferNo, unsigned int IntPageAdr, unsigned char Data)
{
	DF_CS_inactive;																// DataFlash̖ߕؾĂ邽߂
	DF_CS_active;																// CS̖˗LؑւɒӂĂB
	if (1 == BufferNo)															/* ޯ̧1w莞 */
	{
		DF_SPI_RW(Buf1Write);													// ޯ̧1ݖߕM
		DF_SPI_RW(0x00);														// ߑ2޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr>>8));								// ߰ޓڽ޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr));									// ߰ޓڽ޲ĒlM
		DF_SPI_RW(Data);														// ޲ĒlM()
	}
#ifdef USE_BUFFER2
	else
	if (2 == BufferNo)															/* ޯ̧2w莞 */
	{
		DF_SPI_RW(Buf2Write);													// ޯ̧2ݖߕM
		DF_SPI_RW(0x00);														// ߑ2޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr>>8));								// ߰ޓڽ޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr));									// ߰ޓڽ޲ĒlM
		DF_SPI_RW(Data);														// ޲ĒlM()
	}
#endif
}

//*****************************************************************************
//*
//*	֐	: Buffer_Write_Str
//*		: BufferNo	 : ޯ̧1܂2̂ǂgp邩߂܂B
//*			  IntPageAdr : ߰ޓڽ
//*			  No_of_bytes : ǂݍނׂ޲Đ
//*			  *BufferPtr  : ޲ēǂݍ݂Ɏgpׂޯ̧̐擪ڽ
//*	߂l	: Ȃ
//*	ړI	: *BufferPtrwޯ̧DataFlashSRAMޯ̧1܂͕޲ĕ
//*
//*****************************************************************************

void Buffer_Write_Str (unsigned char BufferNo, unsigned int IntPageAdr, unsigned int No_of_bytes, unsigned char *BufferPtr)
{
	unsigned int i;																// Ɨp

	DF_CS_inactive;																// DataFlash̖ߕؾĂ邽߂
	DF_CS_active;																// CS̖˗LؑւɒӂĂB
	if (1 == BufferNo)															/* ޯ̧1w莞 */
	{
		DF_SPI_RW(Buf1Write);													// ޯ̧1ݖߕM
		DF_SPI_RW(0x00);														// ߑ2޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr>>8));								// ߰ޓڽ޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr));									// ߰ޓڽ޲ĒlM
		for( i=0; i<No_of_bytes; i++)											/* (w޲Đ]) */
		{
			DF_SPI_RW(*(BufferPtr));											// ΉAVRޯ̧ʒulM(DataFlashޯ̧)
			BufferPtr++;														// ޯ̧ʒuis
		}
	}
#ifdef USE_BUFFER2
	else
	if (2 == BufferNo)															/* ޯ̧2w莞 */
	{
		DF_SPI_RW(Buf2Write);													// ޯ̧2ݖߕM
		DF_SPI_RW(0x00);														// ߑ2޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr>>8));								// ߰ޓڽ޲ĒlM
		DF_SPI_RW((unsigned char)(IntPageAdr));									// ߰ޓڽ޲ĒlM
		for( i=0; i<No_of_bytes; i++)											/* (w޲Đ]) */
		{
			DF_SPI_RW(*(BufferPtr));											// ΉAVRޯ̧ʒulM(DataFlashޯ̧)
			BufferPtr++;														// ޯ̧ʒuis
		}
	}
#endif
}
//: ڼ޽lRDY/BUSY׸ނĎĂB
//: (IntAdr + No_of_bytes)<buffersizełȂ΂Ȃ炸AȂΔ͈͋Kŋtɑ܂B

//*****************************************************************************
//*
//*	֐	: Buffer_To_Page
//*		: BufferNo : ޯ̧1܂2̂ǂgp邩߂܂B
//*			  PageAdr  : ߰ ڽ
//*	߂l	: Ȃ
//*	ړI	: DataFlashSRAMޯ̧ׯ߰ޓ]()
//*
//*****************************************************************************

void Buffer_To_Page (unsigned char BufferNo, unsigned int PageAdr)
{
	DF_CS_inactive;																// DataFlash̖ߕؾĂ邽߂
	DF_CS_active;																// CS̖˗LؑւɒӂĂB
	if (1 == BufferNo)															/* ޯ̧1w莞 */
	{
		DF_SPI_RW(Buf1ToFlashWE);												// ޯ̧1ׯtݖߕM
		DF_SPI_RW((unsigned char)(PageAdr >> (16 - PageBits)));					// ߰ ڽ޲ĒlM
		DF_SPI_RW((unsigned char)(PageAdr << (PageBits - 8)));					// ߰ ڽ޲ĒlM
		DF_SPI_RW(0x00);														// ߑ4޲ĒlM
	}
#ifdef USE_BUFFER2
	else	
	if (2 == BufferNo)															/* ޯ̧2w莞 */
	{
		DF_SPI_RW(Buf2ToFlashWE);												// ޯ̧2ׯtݖߕM
		DF_SPI_RW((unsigned char)(PageAdr >> (16 - PageBits)));					// ߰ ڽ޲ĒlM
		DF_SPI_RW((unsigned char)(PageAdr << (PageBits - 8)));					// ߰ ڽ޲ĒlM
		DF_SPI_RW(0x00);														// ߑ4޲ĒlM
	}
#endif
	DF_CS_inactive;																// CS̖˗Lؑւœ]()Jn
	DF_CS_active;
	while(!(Read_DF_status() & 0x80));											// ]()(RDY/BUSY=1)܂őҋ@
}

//*****************************************************************************
//*
//*	֐	: Cont_Flash_Read_Enable
//*		: PageAdr	 : ǂݎn߂߰ ڽ
//*			  IntPageAdr : ǂݎn߂߰ޓڽ
//*	߂l	: Ȃ
//*	ړI	: DataFlasḧʒuAǂݍ݊Jn
//*
//*****************************************************************************

void Cont_Flash_Read_Enable (unsigned int PageAdr, unsigned int IntPageAdr)
{
	DF_CS_inactive;																// DataFlash̖ߕؾĂ邽߂
	DF_CS_active;																// CS̖˗LؑւɒӂĂB
	DF_SPI_RW(ContArrayRead);													// AzǂݍݖߕM
	DF_SPI_RW((unsigned char)(PageAdr >> (16 - PageBits)));						// ߰ ڽʒlM
	DF_SPI_RW((unsigned char)((PageAdr << (PageBits - 8))+ (IntPageAdr>>8)));	// ߰ ڽʒl߰ޓڽʒlM
	DF_SPI_RW((unsigned char)(IntPageAdr));										// ߰ޓڽʒlM
	DF_SPI_RW(0x00);															// DataFlashڽŵ߁A4޲đM
	DF_SPI_RW(0x00);
	DF_SPI_RW(0x00);
	DF_SPI_RW(0x00);
}

