/* ŏIXV: RM 2001N117 11:35 */

//*****************************************************************************
//
//      COPYRIGHT (c) ATMEL Norway, 1996-2001
//
// ̎̒쌠ٳATMEL NorwayL܂B
//
// {ATMEL Norway̋܂́A񋟂ꂽ/_ŋK肳ꂽ
// ɏ]āAgp╡ʂł܂B
//
//*****************************************************************************
//
//  ̧......: DATAFLASH.H
//  ......: ATMEL Norway
//  Ώ......: R
//  e......: AT45Dxxxp`Ɗ֐^錾
//  Ŕԍ....:
//
//  N   - VER. - 											- 
//  20010117 - 0.10 - ٍ̧쐬										- RM
//
//*****************************************************************************

#ifndef __DATAFLASH_INCLUDED
#define __DATAFLASH_INCLUDED
#endif


/* ϸے` */

#define sbi(port,bit)	(port |=  (1<<bit))
#define cbi(port,bit)	(port &= ~(1<<bit))

#define SetBit(x,y)		(x |= (y))
#define ClrBit(x,y)		(x &=~(y))
#define ChkBit(x,y)		(x  & (y))


/* DataFlashߕ` */

#define FlashPageRead				0x52	// ߰ޓǂ݂
#define FlashToBuf1Transfer 		0x53	// ؁ޯ̧1߰ޓ]
#define Buf1Read					0x54	// ޯ̧1ǂ݂
#define FlashToBuf2Transfer 		0x55	// ؁ޯ̧2߰ޓ]
#define Buf2Read					0x56	// ޯ̧2ǂ݂
#define StatusReg					0x57	// ڼ޽lǂ݂
#define AutoPageReWrBuf1			0x58	// ޯ̧1oR߰ލď
#define AutoPageReWrBuf2			0x59	// ޯ̧2oR߰ލď
#define FlashToBuf1Compare    		0x60	// ؂ޯ̧1߰ޔr
#define FlashToBuf2Compare	    	0x61	// ؂ޯ̧2߰ޔr
#define ContArrayRead				0x68	// Azǂ݂(:A/B޲̂ݎx)
#define FlashProgBuf1				0x82	// ޯ̧1oR߰ޏ
#define Buf1ToFlashWE   			0x83	// ޯ̧1؂̑gݍݏt߰ޏ
#define Buf1Write					0x84	// ޯ̧1
#define FlashProgBuf2				0x85	// ޯ̧2oR߰ޏ
#define Buf2ToFlashWE   			0x86	// ޯ̧2؂̑gݍݏt߰ޏ
#define Buf2Write					0x87	// ޯ̧2
#define Buf1ToFlash     			0x88	// ޯ̧1؂̑gݍݏȂ߰ޏ
#define Buf2ToFlash		         	0x89	// ޯ̧2؂̑gݍݏȂ߰ޏ

/* DataFlashƂ̲̪pݒ` */

/* DataFlashϸے` */

#define DF_CS_active	cbi(PORTB,0)		// /CS=L
#define DF_CS_inactive	sbi(PORTB,0)		// /CS=H


/* ֐錾 */

void DF_SPI_init (void);																										// 3/Ͻʰ޳SPIݒ(:/SS/CSɎgp)
unsigned char DF_SPI_RW (unsigned char output);																					// SPIϽƂ1޲Ă̓ǂݏ
unsigned char Read_DF_status (void);																							// DataFlashڼ޽l擾
void Page_To_Buffer (unsigned int PageAdr, unsigned char BufferNo);																// ׯ ؂DataFlashSRAMޯ̧߰ޓ]
unsigned char Buffer_Read_Byte (unsigned char BufferNo, unsigned int IntPageAdr);												// DataFlashSRAMޯ̧1޲ēǂ݂
void Buffer_Read_Str (unsigned char BufferNo, unsigned int IntPageAdr, unsigned int No_of_bytes, unsigned char *BufferPtr);		// DataFlashSRAMޯ̧*BufferPtrwޯ̧1܂͕޲ēǂ݂
void Buffer_Write_Enable (unsigned char BufferNo, unsigned int IntPageAdr);														// DataFlashSRAMޯ̧ւ̘A݋
void Buffer_Write_Byte (unsigned char BufferNo, unsigned int IntPageAdr, unsigned char Data);									// DataFlashSRAMޯ̧1޲ď
void Buffer_Write_Str (unsigned char BufferNo, unsigned int IntPageAdr, unsigned int No_of_bytes, unsigned char *BufferPtr);	// *BufferPtrwޯ̧DataFlashSRAMޯ̧1܂͕޲ĕ
void Buffer_To_Page (unsigned char BufferNo, unsigned int PageAdr);																// DataFlashSRAMޯ̧ׯ߰ޓ]()
void Cont_Flash_Read_Enable (unsigned int PageAdr, unsigned int IntPageAdr);													// DataFlasḧʒuAǂݍ݊Jn

