//***************************************************************************
//
//  ̧......: eeprom.c
//  ......: ATMEL Norway
//  Ώ......: ATmega169
//  ߲....: IAR EWAAVR 2.28a
//  e......: AVR Butterfly EEPROMٰ
//  Ŕԍ....: 1.0
//
//  N   - VER. - 											- 
//  20030116 - 1.0  - 쐬											- LHM
//
//***************************************************************************

#include <inavr.h>
#include "eeprom.h"

//*****************************************************************************
//*
//*	֐	: StoreEEPROM
//*		: *pBuffer (擪߲)
//*			  num_bytes (޲Đ)
//*			  EEPROM_START_ADR (EEPROM݊Jnڽ)
//*	߂l	: Ȃ
//*	ړI	: EEPROM
//*
//*****************************************************************************

void StoreEEPROM(char *pBuffer, char num_bytes, unsigned int EEPROM_START_ADR)
{
	unsigned char i;								// Ɨp

	for (i=0;i<num_bytes;i++)						/* w޲Đp */
		__EEPUT(EEPROM_START_ADR++, pBuffer[i]);	// Ή޲EEPROM,߲is
}

//*****************************************************************************
//*
//*	֐	: LoadEEPROM
//*		: *pBuffer (擪߲)
//*			  num_bytes (ǂݍ޲Đ)
//*			  EEPROM_START_ADR (EEPROMǂݍ݊Jnڽ)
//*	߂l	: Ȃ
//*	ړI	: EEPROMǂݍ
//*
//*****************************************************************************

void LoadEEPROM(char *pBuffer, char num_bytes, unsigned int EEPROM_START_ADR)
{
	unsigned char i;								// Ɨp

	for (i=0;i<num_bytes;i++)						/* w޲Đp */
		__EEGET(pBuffer[i], EEPROM_START_ADR++);	// Ή޲EEPROMǂݍ,߲is
}
