//***************************************************************************
//
//  ̧......: usart.c
//  ......: ATMEL Norway
//  Ώ......: ATmega169
//  ߲....: IAR EWAAVR 2.28a
//  e......: AVR Butterfly USARTٰ
//  Ŕԍ....: 1.0
//
//  N   - VER. - 											- 
//  20030116 - 1.0  - 쐬											- LHM
//
//***************************************************************************

#include <inavr.h>
#include "iom169.h"
#include "main.h"
#include "usart.h"

//*****************************************************************************
//*
//*	֐	: USART_Init
//*		: unsigned int baudrate : UBRRl
//*	߂l	: Ȃ
//*	ړI	: USART
//*
//*****************************************************************************

void USART_Init(unsigned int baudrate)
{
	UBRR0H = (unsigned char)(baudrate>>8);								// ]x(UBRR)ݒ
	UBRR0L = (unsigned char)baudrate;
	UCSR0A = (1<<U2X0);													// {ݒ
	UCSR0B = (1<<RXEN0)|(0<<TXEN0)|(0<<RXCIE0)|(0<<UDRIE0);				// M,M֎~,M荞݋֎~
	UCSR0C = (0<<UMSEL0)|(0<<UPM00)|(0<<USBS0)|(3<<UCSZ00)|(0<<UCPOL0);	// 8ޯ,èȂ,1į ޯĔ񓯊ݒ
}

//*****************************************************************************
//*
//*	֐	: Usart_Tx
//*		: char data : M޲Ēl
//*	߂l	: Ȃ
//*	ړI	: USARToR1޲đM
//*
//*****************************************************************************

void Usart_Tx(char data)
{
	while (!(UCSR0A & (1<<UDRE0)));										// Mޯ̧󂫂܂őҋ@
	UDR0 = data;														// USARTMޯ̧֑Mlݒ(MJn)
}

//*****************************************************************************
//*
//*	֐	: Usart_Rx
//*		: Ȃ
//*	߂l	: char : M޲Ēl
//*	ړI	: USART1޲ĎMl擾
//*
//*****************************************************************************

char Usart_Rx(void)
{
	while (!(UCSR0A & (1<<RXC0)));										// M܂őҋ@
	return UDR0;														// MlƋɕA
}
