//***************************************************************************
//
//  ̧......: button.c
//  ......: ATMEL Norway
//  Ώ......: ATmega169
//  ߲....: IAR EWAAVR 2.28a
//  e......: AVR Butterfly ޮèٰ
//  Ŕԍ....: 1.0
//
//  N   - VER. - 											- 
//  20030116 - 1.0  - 쐬											- KS
//
//***************************************************************************

#include <inavr.h>
#include "iom169.h"
#include "main.h"
#include "button.h"
#include "timer0.h"

/* ϐ` */

extern char gPowerSaveTimer;								// ȓd͈ڍsԌvl
unsigned char gButtonTimeout = FALSE;						// ޮèԍXV׸(ݸޖh~up)
char KEY = NULL;											// ޮèԔԍ(l:SOFF)
char KEY_VALID = FALSE;										// ޮèԔԍL׸(l:)
char CountdownTimerHandle;									// 10msPʉ~vlo^ԍ

//*****************************************************************************
//*
//*	֐	: Button_Init
//*		: Ȃ
//*	߂l	: Ȃ
//*	ړI	: ޮè֘Aݏ
//*
//*****************************************************************************

void Button_Init(void)
{
	cbi(DDRB,7);											// PB7()͐ݒ
	cbi(DDRB,6);											// PB6()͐ݒ
	cbi(DDRB,4);											// PB4()͐ݒ
	PORTB |= PINB_MASK;										// PB7/6/4ٱߐݒ
	DDRE = 0x00;											// PE7`0͐ݒ
	PORTE |= PINE_MASK;										// PE3/2ٱߐݒ
	/* ݕω荞݋ */
	PCMSK0 = PINE_MASK;										// PCINT3()/2()荞݋
	PCMSK1 = PINB_MASK;										// PCINT15()/14()/12()荞݋
	EIFR = (1<<PCIF0)|(1<<PCIF1);							// ݕω荞1,0Q荞ݗv׸މ
	EIMSK = (1<<PCIE0)|(1<<PCIE1);							// ݕω荞1,0Q荞݋
	CountdownTimerHandle = Timer0_AllocateCountdownTimer();	// 10msPʉ~vl쐬(o^)
}
#pragma vector = PCINT0_vect
__interrupt void PCINT0_interrupt(void)						// ݕω荞0Q荞޸ݒ
{
	PinChangeInterrupt();									// ݕω荞ݏ
}
#pragma vector = PCINT1_vect
__interrupt void PCINT1_interrupt(void)						// ݕω荞1Q荞޸ݒ
{
	PinChangeInterrupt();									// ݕω荞ݏ
}

//*****************************************************************************
//*
//*	֐	: PinChangeInterrupt
//*		: Ȃ
//*	߂l	: Ȃ
//*	ړI	: ޮèԌ
//*
//*****************************************************************************

void PinChangeInterrupt(void)
{
	char buttons;											// ޮè _ޯĒl
	char key;												// ޮèԔԍ

	// 擾:
	// Bit             7   6   5   4   3   2   1   0
	// ---------------------------------------------
	// PORTB           B   A       O
	// PORTE                           D   C
	// ---------------------------------------------
	// PORTB | PORTE   B   A       O   D   C
	// =============================================

	buttons = (~PINB) & PINB_MASK;							// ,,_ޯĒl擾
	buttons |= (~PINE) & PINE_MASK;							// ,_ޯĒl擾
	if (buttons & (1<<BUTTON_A))							// ONȂAޮèԔԍ=4
		key = KEY_PLUS;
	else if (buttons & (1<<BUTTON_B))						// ONȂAޮèԔԍ=5
		key = KEY_MINUS;
	else if (buttons & (1<<BUTTON_C))						// ONȂAޮèԔԍ=3
		key = KEY_PREV;
	else if (buttons & (1<<BUTTON_D))						// ONȂAޮèԔԍ=2
		key = KEY_NEXT;
	else if (buttons & (1<<BUTTON_O))						// ONȂAޮèԔԍ=1
		key = KEY_ENTER;
	else													// SOFFȂAޮèԔԍ=0
		key = KEY_NULL;
	if(key != KEY_NULL)										/* ON */
	{
		if(gButtonTimeout)									/* (ޮèԍXV(ݸޖh~ԈȊO)) */
		{
			if (!KEY_VALID)									/* ((ONȂ)) */
			{
				KEY = key;									// ޮèԔԍSϐ֕
				KEY_VALID = TRUE;							// ޮèԔԍL׸ސݒ
			}
			gButtonTimeout = FALSE;							// ޮèԍXV׸މ(ݸޖh~Ԍv)
		}
	}
	EIFR = (1<<PCIF1) | (1<<PCIF0);							// ݕω荞1,0Q荞ݗv׸މ
	gPowerSaveTimer = 0;									// ȓd͈ڍsԌvl
}

//*****************************************************************************
//*
//*	֐	: getkey
//*		: Ȃ
//*	߂l	: char (ޮèԔԍ)
//*	ړI	: ޮèԔԍ擾
//*
//*****************************************************************************

char getkey(void)
{
	char k;													// ޮèԔԍ

	__disable_interrupt();									// S荞݋֎~
	if (KEY_VALID)											/* ޮèԔԍL */
	{
		k = KEY;											// ޮèԔԍ
		KEY_VALID = FALSE;									// ޮèԔԍL׸މ
	}
	else													/* ޮèԔԍ */
		k = KEY_NULL;										// SOFFޮèԔԍ擾
	__enable_interrupt();									// S荞ݍċ
	return k;												// ޮèԔԍƋɕA
}
