//***************************************************************************
//
//  ̧......: test.c
//  ......: ATMEL Norway
//  Ώ......: ATmega169
//  ߲....: IAR EWAAVR 2.28a
//  e......: AVR Butterfly ٰ
//  Ŕԍ....: 1.0
//
//  N   - VER. - 											- 
//  20030116 - 1.0  - 쐬											- LHM
//
//***************************************************************************

#include <inavr.h>
#include "iom169.h"
#include "main.h"
#include "test.h"
#include "button.h"
#include "LCD_driver.h"
#include "LCD_functions.h"
#include "Sound.h"
#include "ADC.h"
#include "RTC.h"
#include "dataflash.h"

/* 萔` */

#define pLCDREG_test (*(char *)(0xEC))					// LCDDRgI/Oڽʒu

//*****************************************************************************
//*
//*	֐	: Test
//*		: Ȃ
//*	߂l	: Ȃ
//*	ړI	: e
//*
//*****************************************************************************

void Test(void)
{
	char input = 0;										// ޮèԔԍ
	char i;												// Ɨp
	char j;												// Ɨp
	int integer;										// ܰޒƕϐ
	int temp_hi;										// PWM޲Ēl

	TIMSK2 = 0;											// Đւ̉er̂/2(RTC)S荞݋֎~

	/* ޮè  */

	LCD_puts("Test",0);									// LCDޯ̧"Test"ݒ
	while(input != KEY_ENTER)							// ޮèON܂őҋ@
	{
		input = getkey();								// ݂̼ޮèԔԍ擾
	}
	LCD_puts("Left",0);									// LCDޯ̧"Left"ݒ
	while(input != KEY_PREV)							// ޮèON܂őҋ@
	{
		input = getkey();								// ݂̼ޮèԔԍ擾
	}
	LCD_puts("Up",0);									// LCDޯ̧"Up"ݒ
	while(input != KEY_PLUS)							// ޮèON܂őҋ@
	{
		input = getkey();								// ݂̼ޮèԔԍ擾
	}
	LCD_puts("Right",0);								// LCDޯ̧"Right"ݒ
	while(input != KEY_NEXT)							// ޮèON܂őҋ@
	{
		input = getkey();								// ݂̼ޮèԔԍ擾
	}
	LCD_puts("Down",0);									// LCDޯ̧"Down"ݒ
	while(input != KEY_MINUS)							// ޮèON܂őҋ@
	{
		input = getkey();								// ݂̼ޮèԔԍ擾
	}

	/*  */

	LCD_puts("Sound",0);								// LCDޯ̧"Sound"ݒ
	input = 0;											// ޮèԔԍ(SOFF)
	while(input != KEY_ENTER)							// ޮèON܂őҋ@
	{
		input = getkey();								// ݂̼ޮèԔԍ擾
	}
	TCCR1A = (1<<COM1A1);								// OC1A㏸v=H,~v=Lݒ
	TCCR1B = (1<<WGM13) | (1<<CS10);					// lICR1ňʑ/gPWMn
	sbi(TCCR1B, 0);										// OuȂ/1n
	OCR1AH = 0;											// ő剹ʒl(OCR1A)ݒ
	OCR1AL = 80;										// (OCR1AL̂ݎgp,OCR1AH=펞0,PWM=)
	for(integer = 200; integer >= 100; integer -= 5)	/* 0.6sԎg㏸ */
	{
		temp_hi = integer;								// PWMl
		ICR1H = (temp_hi >>= 8);						// PWM޲Ēlݒ
		ICR1L = integer;								// PWM޲Ēlݒ
		Delay(30);										// 30msҋ@
	}
	TCCR1A = 0;											// /1~(Ԑݒ)
	TCCR1B = 0;

	/* LCD */

	LCD_puts("LCD test",0);								// LCDޯ̧"LCD test"ݒ
	while(!(PINB & (1<<PORTB4)));						// ޮèOFF܂őҋ@
	input = 0;											// ޮèԔԍ(SOFF)
	while(input != KEY_ENTER)							// ޮèON܂őҋ@
	{
		input = getkey();								// ݂̼ޮèԔԍ擾
	}
	cbi(LCDCRA, LCDIE);									// LCDڰъJn荞݋֎~
	for(i = 0; i < 20; i++)								/* SLCDDRɑSē_lݒ */
	{
		*(&pLCDREG_test + i) = 0xFF;					// ΉLCDDRɑSē_lݒ
	}
	while(!(PINB & (1<<PORTB4)));						// ޮèOFF܂őҋ@
	Delay(100);											// 100msҋ@
	while((PINB & (1<<PORTB4)));						// ޮèON܂őҋ@(LCD荞݂ݸޏsȂߒڔ)
	sbi(LCDCRA, LCDIE);									// LCDڰъJn荞ݍċ

	/* x莎 */

	ADC_init(0);										// xA/Dϊ
	integer = ADC_read();								// xA/Dϊl擾
	if( (integer < 452) || (integer > 586) )			/* 21`30ȊO */
	{
		LCD_puts("Error Temperature",0);				// LCDޯ̧"Error Temperature"ݒ
		ErrorBeep();									// x
		input = 0;										// ޮèԔԍ(SOFF)
		while(input != KEY_ENTER)						// ޮèON܂őҋ@
		{
			input = getkey();							// ݂̼ޮèԔԍ擾
		}
		ADC_periphery();								// A/Dϊl擾,xvZLCDޯ̧ݒ
		LCD_UpdateRequired(TRUE, 0);					// LCD\XVv׸ސݒ
		input = 0;										// ޮèԔԍ(SOFF)
		while(input != KEY_ENTER)						// ޮèON܂őҋ@
		{
			input = getkey();							// ݂̼ޮèԔԍ擾
		}
	}

	/* d莎 */

	ADC_init(1);										// dA/Dϊ
	integer = ADC_read();								// dA/Dϊl擾
	if( (integer < 298) || (integer > 320) )			/* 4.8`5.2VȊO */
	{
		LCD_puts("Error Voltage",0);					// LCDޯ̧"Error Voltage"ݒ
		ErrorBeep();									// x
		input = 0;										// ޮèԔԍ(SOFF)
		while(input != KEY_ENTER)						// ޮèON܂őҋ@
		{
			input = getkey();							// ݂̼ޮèԔԍ擾
		}
		ADC_periphery();								// A/Dϊl擾,x/d/xvZLCDޯ̧ݒ
		LCD_UpdateRequired(TRUE, 0);					// LCD\XVv׸ސݒ
		input = 0;										// ޮèԔԍ(SOFF)
		while(input != KEY_ENTER)						// ޮèON܂őҋ@
		{
			input = getkey();							// ݂̼ޮèԔԍ擾
		}
	}

	/* x莎 */

	LCD_puts("Light",0);								// LCDޯ̧"Light"ݒ
	input = 0;											// ޮèԔԍ(SOFF)
	while(input != KEY_ENTER)							// ޮèON܂őҋ@
	{
		input = getkey();								// ݂̼ޮèԔԍ擾
	}
	ADC_init(2);										// xA/Dϊ
	input = 0;											// ޮèԔԍ(SOFF)
	while(input != KEY_ENTER)							// ޮèON܂őҋ@
	{
		ADC_read();										// xA/Dϊl擾(lXV)
		ADC_periphery();								// A/Dϊl擾,x/d/xvZLCDޯ̧ݒ
		__no_operation();								// NOP()
		LCD_UpdateRequired(TRUE, 0);					// LCD\XVv׸ސݒ
		input = getkey();								// ݂̼ޮèԔԍ擾
	}

	/* DataFlash */

	DF_CS_inactive;										// DataFLashIݒ
	DF_CS_active;										// DataFLashIݒ
	for(j=0; j<50; j++)									// DataFLashޯ̧150޲ď
		Buffer_Write_Byte (1,j,j);
	Buffer_To_Page (1,1);								// DataFLashޯ̧1ׯ֓]()
	DF_CS_inactive;										// DataFLashIݒ
	DF_CS_active;										// DataFLashIݒ
	Cont_Flash_Read_Enable (1,0);						// Aړǂݍ݋
	for(j=0;j<50;j++)									/* 50޲ĕǂݏoƍ */
	{
		if(j != DF_SPI_RW(0x00))						// ΉǂݏolsvȂA
		{
			LCD_puts("Error Dataflash",0);				// LCDޯ̧"Error Dataflash"ݒ
			ErrorBeep();								// x
			input = 0;									// ޮèԔԍ(SOFF)
			while(input != KEY_ENTER)					// ޮèON܂őҋ@
			{
				input = getkey();						// ݂̼ޮèԔԍ擾
			}
			break;										// fo
		}
	}
	DF_CS_inactive;										// DataFLashIݒ

	/* ĳ Rev.ԍ\ */

	i = Revision(1);									// ĳ Rev.ԍ\
	input = 0;											// ޮèԔԍ(SOFF)
	while(input != KEY_ENTER)							// ޮèON܂őҋ@
	{
		input = getkey();								// ݂̼ޮèԔԍ擾
	}

	/* ؾ */

	WDTCR = (1<<WDCE) | (1<<WDE);						// ŒZԂųޯ ϋN
	while(1);											// ޯ ؾĂ܂őҋ@
}

//*****************************************************************************
//*
//*	֐	: ErrorBeep
//*		: Ȃ
//*	߂l	: Ȃ
//*	ړI	: x
//*
//*****************************************************************************

void ErrorBeep(void)
{
	TCCR1A = (1<<COM1A1);								// OC1A㏸v=H,~v=Lݒ
	TCCR1B = (1<<WGM13) | (1<<CS10);					// lICR1ňʑ/gPWMn
	sbi(TCCR1B, 0);										// OuȂ/1n
	OCR1AH = 0;											// ő剹ʒl(OCR1A)ݒ
	OCR1AL = 80;										// (OCR1AL̂ݎgp,OCR1AH=펞0,PWM=)
	ICR1H = 1;											// PWM(2G)ݒ
	ICR1L = 0x3F
	Delay(50);											// 50msҋ@
	ICR1H = 1;											// PWM(2C)ݒ
	ICR1L = 0xDE;
	Delay(300);											// 300msҋ@
	TCCR1A = 0;											// /1~(Ԑݒ)
	TCCR1B = 0;
}
