//****************************************************************************
//*
//* Copyright (C) 1996-1998 Atmel Corporation
//*
//* ̧ٖ		: main.c
//* 쐬N	: 1999N616
//* ŏIXV	: 1999N123
//* 		: BBrandal, PKastnes, ARodland, LHM
//*
//* e		: {۸тް۰ޔ\͕tAVRׯ/EEPROM̎ȓǂݏ
//*				  ܂B
//*
//****************************************************************************

#define ENABLE_BIT_DEFINITIONS

#include <inavr.h>
#include "iom169.h"
#include "assembly.h"

#define _ATMEGA169 

/* ްė̈e (1IAĂɂĂ) */

//#define _B128															// 128
//#define _B256															// 256
//#define _B512															// 512
#define _B1024															// 1024

#define devtype 0x75													// x޲(ATmega16) (2003N324,AVRprogATmega169Ή̂)
//#define devtype 0x79													// x޲(ATmega169)

#include "main.h"

/* ֐錾 */

void sendchar(char );													// 1޲USARTM
char recchar(void);														// 1޲USARTM
//void USART_Init(unsigned int );										// USART
unsigned char BufferLoad(unsigned int , unsigned char );				// ׯ/EEPROM A(ޯ̧)
void BlockRead(unsigned int , unsigned char );							// ׯ/EEPROMAǂݏo
void OSCCAL_calibration(void);											// O32.768kHzؽقOSCCALZ
void Delay(unsigned int);												// 1msPʑҋ@

/* ϐ` */

unsigned int address;													// ǂݏڽl
unsigned char device;													// w޲

//*****************************************************************************
//*
//*	֐	: main
//*	ړI	: 又
//*
//*****************************************************************************

__C_task void main(void)
{
	void (*funcptr)( void ) = 0x0000;									// p̈Jnʒu(l=$0000)

	unsigned int tempi;													// w޲Đ
	char val;															// USARTMl
	char OK = 1;														// AVRprogڑ׸(l=ڑ)

	OSCCAL_calibration();												// OSCCALlZ(32.768kHz)
	ACSR = (1<<ACD);													// ۸ޔr퓮֎~
	DIDR1 = (7<<ADC0D);													// ADC2`0޼ٓ͋֎~			[Bug:DIDR0]
	PORTB = 0xFF;														// ߰Bٱߐݒ
	PORTE = 0xFF;														// ߰Eٱߐݒ
	CLKPR = (1<<CLKPCE);												// OulύXޯĐݒ
	CLKPR = (1<<CLKPS1);												// 4Ou ۯݒ(8MHz/4=2MHz):19200bpsgp̂
	UBRR0H = 0;															// 19200bpsݒ
	UBRR0L = 12;														// 19200bpsݒ
	UCSR0A = (1<<U2X0);													// USART{ݒ
	UCSR0B = (1<<RXEN0)|(1<<TXEN0)|(0<<RXCIE0)|(0<<UDRIE0);				// USARTM,M荞݋֎~
	UCSR0C = (0<<UMSEL0)|(0<<UPM00)|(0<<USBS0)|(3<<UCSZ00)|(0<<UCPOL0);	// 8ޯ,èȂ,1į ޯĔ񓯊ݒ
	MCUCR = (1<<IVCE);													// 荞޸ύXޯĐݒ
	MCUCR = (1<<IVSEL);													// ްė̈抄荞޸ɕύX
	__enable_interrupt();												// S荞݋
	PCMSK1 = (1<<PORTB6) | (1<<PORTB4);									// Ɓݕω荞݂̂݋
	EIFR = (1<<PCIF1);													// ΉݕωQ荞ݗv׸މ
	EIMSK = (1<<PCIE1);													// ΉݕωQ荞݋

	/* AVRprogڑ */

	for(;OK;)															/* AVRprogڑ܂ŏp */
	{
		if(!(PINB & (1<<PORTB6)))										/* (ON) */
		{
			MCUCR = (1<<IVCE);											// 荞޸ύXޯĐݒ
			MCUCR = (0<<IVSEL);											// p̈抄荞޸ɕA(ύX)
			funcptr();													// pJRESET޸s
		}
		else if(PINB & (1<<PORTB4))										/* (OFF) */
		{
			UCSR0A = 0x02;												// USART{ݒ
			SMCR = (3<<SM0) | (1<<SE);									// ܰޓw,ذߖߋݒ
			__sleep();													// ܰ ذߓڍs
			SMCR = 0;													// NAذߖߋ֎~ݒ
		}
		else															/* (ON) */
		{
			val = recchar();											// USARTMl擾(M܂őҋ@)
			if(val == 0x1B)												/* ((ESCM)) */
			{															// (AVRprogڑ)
				while (val != 'S')										/* ((( ʗv(='S')܂őҋ@))) */
				{
					val = recchar();									// USARTMl擾(M܂őҋ@)
				}
				sendchar('A');											// ʖUSARTM
				sendchar('V');
				sendchar('R');
				sendchar('B');
				sendchar('O');
				sendchar('O');
				sendchar('T');
				__disable_interrupt();									// S荞݋֎~
				OK = 0;													// AVRprogڑ׸މ
			}
			else														/* ((ESCȊOM)) */
				sendchar('?');											// USARTM
		}
	}

	/* AVRprogڑ㏈ */

	for(;;)
	{
		val=recchar();													// USARTMl擾(M܂őҋ@)
		if(val=='a')													/* 'a' isL₢킹ߎ */
		{
			sendchar('Y');												// is(m)USARTM
		}
		else if(val=='A')												/* 'A' ڽw薽ߎ */
		{
			address=recchar();											// ڽ(USARTM)l擾(M܂őҋ@)
			address=(address<<8)|recchar();								// ڽʒlUSART擾ڽl
			address=address<<1;											// (ܰ)Pʂ޲ĒPʱڽɕϊ
			sendchar('\r');												// m艞USARTM
		}
		else if(val=='b')												/* 'b' ޯ̧L₢킹ߎ */
		{
			sendchar('Y');												// ޯ̧(m)USARTM
			sendchar((UART_RX_BUFFER_SIZE >> 8) & 0xFF);				// ޲ĒPޯ̧eʏ޲ĒlUSARTM
			sendchar(UART_RX_BUFFER_SIZE & 0xFF);						// ޲ĒPޯ̧eʉ޲ĒlUSARTM
		}
		else if(val=='B')												/* 'B' ׯ/EEPROM A(ޯ̧) */
		{
			tempi = recchar() << 8;										// ޲Đ(USARTM)l擾(M܂őҋ@)
			tempi |= recchar();											// ޲Đ(USARTM)l擾(M܂őҋ@)(޲Đ)
			val = recchar();											// ʎq{'E'|'F'}(USARTM)擾(M܂őҋ@)
			sendchar (BufferLoad(tempi,val));							// ޯ̧ݏΉUSARTM
		}
		
		else if(val == 'g')												/* 'g' ׯ/EEPROM Aǂݏo */
		{
			tempi = (recchar() << 8) | recchar();						// 2޲Ă޲Đ(USARTM)l擾(M܂őҋ@)
			val = recchar();											// ʎq{'E'|'F'}(USARTM)擾(M܂őҋ@)
			BlockRead(tempi,val);										// ׯ/EEPROMAǂݏo
		}
//		else if(val=='c')												/* 'c' ׯ޲ď */
//		{
//			ldata=recchar();											// ޲(USARTM)l擾(M܂őҋ@)
//			sendchar('\r');												// m艞USARTM
//		}
//		else if(val== 'C')												/* 'C' ׯ޲ď */
//		{
//			data=ldata|(recchar()<<8);									// ޲(USARTM)l擾(M܂őҋ@)(ꍇ)
//			if (device == devtype)										// w޲Ǝx޲vȂA
//			{
//				fill_temp_buffer(data,(address));						// ߰ވꎞޯ̧Ɍݒ(ASMٰ)
//			}
//			address=address+2;  										// ڽvlis(+2:P)
//			sendchar('\r');												// m艞USARTM
//		}
		else if(val=='e')												/* 'e' ߏ */
		{
			if (device == devtype)										/* (w޲Ǝx޲v) */ 
			{
				for(address=0;address < APP_END;address += PAGESIZE)	/* ((Sp̈^ޏ)) */
				{
					write_page(address,(1<<PGERS) + (1<<SPMEN));		// Ή߰ޏ
					write_page(address,(1<<RWWSRE) + (1<<SPMEN));		// RWẄċ
				}
			}
			write_page(address,(1<<RWWSRE) + (1<<SPMEN));				// RWẄċ
			sendchar('\r');												// m艞USARTM
		}
		else if(val=='E')												/* 'E' ؾĔo */
		{
			WDTCR = (1<<WDCE) | (1<<WDE);								// ŏԊu(15ms)ųޯދ
			sendchar('\r');												// m艞USARTM
		}
//		else if(val=='l')												/* 'l' ۯ ޯĐݒ */
//		{
//			if (device == devtype)										// w޲Ǝx޲vȂA
//			{
//				write_lock_bits(recchar());								// ۯ ޯĐݒ(ASMٰ)
//			}
//			sendchar('\r');												// m艞USARTM
//		}
//		else if(val== 'm')												/* 'm' ׯ ߰ޏ */
//		{
//			if (device == devtype)										/* (w޲Ǝx޲v) */ 
//			{
//				write_page(address,(1<<PGERS) + (1<<SPMEN));			// Ή߰ޏ
//				write_page((address),0x05);								// Ή߰ޏ
//				write_page(address,(1<<RWWSRE) + (1<<SPMEN));			// RWẄċ
//			}
//			sendchar('\r');												// m艞USARTM
//		}
		else if(val=='P')												/* 'P' ۸ݸޓڍs */
		{
			sendchar('\r');												// m艞USARTM
		}
		else if(val=='L')												/* 'L' ۸ݸޓ씲o */
		{
			sendchar('\r');												// m艞USARTM
		}
		else if (val=='p')												/* 'p' ݊`擾 */
		{
			sendchar('S');												// SPI(ر)`lUSARTM
		}
//		else if(val=='R')												/* 'R' ׯ ǂݏo */
//		{
//			write_page(0,(1<<RWWSRE) + (1<<SPMEN));						// RWẄċ
// //			SPMCSR = (1<<RWWSRE) | (1<<SPMEN);
// //			__store_program_memory();
// //			while((SPMCSR & 0x01));
//			intval=read_program_memory(address,0x00);					// Ήڽʒuׯǂݏo(ASMٰ)
//			sendchar((char)(intval>>8));								// ޲ĒlUSARTM
//			sendchar((char)intval);										// ޲ĒlUSARTM
//			address=address+2;  										// ڽvlis(+2:P)
//		}
//		else if (val == 'D')											/* 'D' EEPROM޲ď */
//		{
//			if (device == devtype)										/* (w޲Ǝx޲v) */ 
//			{
//				EEARL = address;										// EEPROMڽw
//				EEARH = (address >> 8);
//				address++;												// ڽvlis(+1)
//				EEDR = recchar();										// USARTMlݒlƂĎw
//				EECR |= (1<<EEMWE);										// EEPROMϽ݋
//				EECR |= (1<<EEWE);										// EEPROM݊Jn
//				while (EECR & (1<<EEWE))								// ݊(EEWE=0)܂őҋ@
//				;
//			}
//			sendchar('\r');												// m艞USARTM
//		}
//		else if (val == 'd')											/* 'd' EEPROM ޲ēǂݏo */
//		{
//			EEARL = address;											// EEPROMڽw
//			EEARH = (address >> 8);
//			address++;													// ڽvlis(+1)
//			EECR |= (1<<EERE);											// EEPROMǂݏoJn
//			sendchar(EEDR);												// EEPROMΉǂݏolUSARTM
//		}
//		else if(val=='F')												/* 'F' ˭ޓǂݏo */
//		{
//			sendchar(read_program_memory(0x0000,0x09));					// ˭ޓǂݏo(ASMٰ)lUSARTM
//		}
//		else if(val=='r')												/* 'r' ۯ ޯēǂݏo */
//		{
//			sendchar(read_program_memory(0x0001,0x09));					// ۯ ޯēǂݏo(ASMٰ)lUSARTM
//		}
//		else if(val=='N')												/* 'N' ˭ޓǂݏo */
//		{
//			sendchar(read_program_memory(0x0003,0x09));					// ˭ޓǂݏo(ASMٰ)lUSARTM
//		}
//		else if(val=='Q')												/* 'Q' g˭ޓǂݏo */
//		{
//			sendchar(read_program_memory(0x0002,0x09));					// g˭ޓǂݏo(ASMٰ)lUSARTM
//		}
		else if(val=='t')												/* 't' x޲擾 */
		{
			sendchar(devtype);											// x޲USARTM
			sendchar(0);												// IqUSARTM
		}
		else if ((val=='x')||(val=='y'))								/* 'x' LED_ ܂ 'y' LED */
		{
			recchar();													// LED_/wl(USARTM)擾(M܂őҋ@)
			sendchar('\r');												// m艞USARTM
		}
		else if (val=='T')												/* 'T' ޲`I */
		{
			device = recchar();											// ޲`(USARTM)擾(M܂őҋ@)
			sendchar('\r');												// m艞USARTM
		}
		else if (val=='S')												/* 'S' ĳʎq擾 */
		{
			sendchar('A');												// "AVRBOOT"USARTM
			sendchar('V');
			sendchar('R');
			sendchar('B');
			sendchar('O');
			sendchar('O');
			sendchar('T');
		}
		else if (val=='V')												/* 'V' ĳVer.ԍ擾 */
		{
			sendchar('2');												// "20"USARTM
			sendchar('0');
		}
		else if (val=='s')												/* 's' [޲Ď擾 */
		{
			sendchar(sig_byte1);										// [1޲ĒlUSARTM
			sendchar(sig_byte2);										// [2޲ĒlUSARTM
			sendchar(sig_byte3);										// [3޲ĒlUSARTM
		}
		else if(val!=0x1b)												/* gȊO */
		{
			sendchar('?');												// USARTM
		}
	}
}

//*****************************************************************************
//*
//*	֐	: USART_Init
//*		: unsigned int baudrate : UBRRwl
//*	߂l	: Ȃ
//*	ړI	: USART
//*
//*****************************************************************************
/*
void USART_Init(unsigned int baudrate)
{
	UBRR0H = (unsigned char)(baudrate>>8);								// UBRR(bpsw)lʐݒ
	UBRR0L = (unsigned char)baudrate;									// UBRR(bpsw)lʐݒ
	UCSR0A = (1<<U2X0);													// USART{ݒ
	UCSR0B = (1<<RXEN0)|(1<<TXEN0)|(0<<RXCIE0)|(0<<UDRIE0);				// USARTM,M荞݋֎~
	UCSR0C = (0<<UMSEL0)|(0<<UPM00)|(0<<USBS0)|(3<<UCSZ00)|(0<<UCPOL0);	// 8ޯ,èȂ,1į ޯĔ񓯊ݒ
}
*/

//*****************************************************************************
//*
//*	֐	: sendchar
//*		: char data : Ml
//*	߂l	: Ȃ
//*	ړI	: 1޲USARTM
//*
//*****************************************************************************

void sendchar(char data)
{
	int i = 0;															// ĎԌvl

	UDR0 = data;														// MlUSARTɐݒ
	if(SREG & 0x80)														/* S荞݋ */
	{
		while (!(UCSR0A&0x40) && (i<10000))								/* (M܂͊ĎԌo߂܂őҋ@) */
		{
			i++;														// ĎԌvlis
		}
	}
	else																/* S荞݋֎~ */
		while(!(UCSR0A&0x40));											// USARTM܂őҋ@
	UCSR0A=UCSR0A|0x40;													// M׸މ
}

//*****************************************************************************
//*
//*	֐	: recchar
//*		: Ȃ
//*	߂l	: USARTMl
//*	ړI	: 1޲USARTM
//*
//*****************************************************************************

char recchar(void)
{
	int i = 0;															// ĎԌvl

	if(SREG & 0x80)														/* S荞݋ */
	{
		while (!(UCSR0A & (1<<RXC0)) && (i<10000))						/* (M܂͊ĎԌo߂܂őҋ@) */
		{
			i++;														// ĎԌvlis
		}
	}
	else																/* S荞݋֎~ */
		while(!(UCSR0A & (1<<RXC0)));									// USARTM܂őҋ@
	return UDR0;														// USARTMlƋɕA
}

//*****************************************************************************
//*
//*	֐	: PCINT1_interrupt
//*	ړI	: ݕω1Q荞
//*
//*****************************************************************************

#pragma vector = PCINT1_vect
__interrupt void PCINT1_interrupt(void)
{
//	__no_operation();
}

//*****************************************************************************
//*
//*	֐	: BufferLoad
//*		: unsigned int size : ޲Đ
//*			  unsigned char mem : ؎('E':EEPROM|'F':ׯ )
//*	߂l	: /s
//*	ړI	: ׯ/EEPROM A(ޯ̧)
//*
//*****************************************************************************

unsigned char BufferLoad(unsigned int size, unsigned char mem)
{
	int data, tempaddress;												// ްl, Jnڽ

	tempaddress = address;												// ڽl(Jnڽۑ)
	if (device == devtype)												/* w޲Ǝx޲v */ 
	{
		if (mem == 'F')													/* (ׯ('F')w莞) */
		{
			do															/* ((w޲Đ,M߰ވꎞޯ̧])) */
			{
				data = recchar();										// ޲Ēl(USARTM)擾(M܂őҋ@)
				data |= (recchar() << 8);								// ޲Ēl(USARTM)擾(M܂őҋ@)(ꍇ)
				fill_temp_buffer(data,(address));						// ߰ވꎞޯ̧Ɍݒ(ASMٰ)
				address=address+2;  									// ڽvlis(+2:P)
				size -= 2;												// ޲Đvl(-2:P)
			}while(size);												// w޲ĐI܂Ōp
//			if(address < 0x70)
//				__no_operation();			//tempi +=2;	//DEBUG lhmo fordi en fr feil ved lesing av d to siste bytes p siste pagen...
			tempaddress &= 0xFF80;										// ߰ޒPʂł̊Jnڽ擾(߰ޓSޯ=0)
			write_page((tempaddress),0x05);								// ߰ޏ(ASMٰ)
			write_page(tempaddress,(1<<RWWSRE) + (1<<SPMEN));			// RWẄċ(ASMٰ)
			if (address != (address & 0xFF80))							// ڽ߰ދEȊOȂA
			{
				address &= 0xFF80;										// ʒu߰ސ擪ڽ擾
				address += PAGESIZE;									// ߰ސ擪ڽɕύX
			}
//			__no_operation();
		}
		if (mem == 'E')													/* (EEPROM('E')w莞) */ 
		{
			do															/* ((w޲Đ,Mˏ)) */
			{
//	 			PORTB |= 0x10;				//DEBUG!!! lhmo 090303
				EEARL = address;										// EEPROMڽw
				EEARH = (address >> 8);
				address++;												// ڽvlis(+1)
				EEDR = recchar();										// USARTMlݒlƂĎw
				EECR |= (1<<EEMWE);										// EEPROMϽ݋
				EECR |= (1<<EEWE);										// EEPROM݊Jn
				while (EECR & (1<<EEWE))								// ݊(EEWE=0)܂őҋ@
				;
				size--;													// ޲Đvl(-1)
			}while(size);												// w޲ĐI܂Ōp
		}
		return '\r';													// Iōm艞ƋɕA
	}
	return 0;															// w޲Ǝx޲svŎsƋɕA
}

//*****************************************************************************
//*
//*	֐	: BlockRead
//*		: unsigned int size : ǂݏo޲Đ
//*			  unsigned char mem : ؎('E':EEPROM|'F':ׯ )
//*	߂l	: Ȃ
//*	ړI	: ׯ/EEPROMAǂݏo
//*
//*****************************************************************************

void BlockRead(unsigned int size, unsigned char mem)
{
	unsigned int data;

	if (mem == 'E')														/* EEPROM('E')w莞 */ 
	{
		do																/* (w޲Đ,ǂݏoˑM) */
		{
			EEARL = address;											// EEPROMڽw
			EEARH = (address >> 8);
			address++;													// ڽvlis(+1)
			EECR |= (1<<EERE);											// EEPROMǂݏoJn
			sendchar(EEDR);												// EEPROMΉǂݏolUSARTM
			size--;														// ޲Đvl(-1)
		}while (size);													//  w޲ĐI܂Ōp
	}
	else																/* ׯ('F')w莞 */ 
	{
		do																/* (w޲Đ,ǂݏoˑM) */
		{
			data = read_program_memory(address,0x00);					// ׯΉʒul擾(ׯǂݏo)
			sendchar((char)data);										// ޲ĒlUSARTM
			sendchar((char)(data >> 8));								// ޲ĒlUSARTM
			address += 2;												// ڽvlis(+2:P)
//			if(address == 0x2582)				// DEBUG
//				__no_operation();
			size -= 2;													// ޲Đvl(-2:P)
		}while (size);													//  w޲ĐI܂Ōp
	}
}

//*****************************************************************************
//*
//*	֐	: OSCCAL_calibration
//*		: Ȃ
//*	߂l	: Ȃ
//*	ړI	: O32.768kHzؽقOSCCALZ
//*
//*****************************************************************************

void OSCCAL_calibration(void)
{
	unsigned char calibrate = FALSE;									// Z׸
	int temp;															// /1vl
	unsigned char tempL;												// /1vl޲Ēl

	CLKPR = (1<<CLKPCE);												// OulύXޯĐݒ
	CLKPR = (1<<CLKPS1) | (1<<CLKPS0);									// 8Ou ۯݒ(8MHz/8=1MHz)
	TIMSK2 = 0;															// /2S荞݋֎~
	ASSR = (1<<AS2);													// /2񓯊ݒ
	OCR2A = 200;														// /2rl
	TIMSK0 = 0;															// /1S荞݋֎~
	TCCR1B = (1<<CS10);													// /1OuȂN
	TCCR2A = (1<<CS20);													// /2OuȂN
	while((ASSR & 0x01) | (ASSR & 0x04));								// /2֌Wڼ޽XV܂őҋ@
	Delay(1000);														// O32.768kHzؽٔUҋ@
	while(!calibrate)													/* Z܂ł̌p */
	{
		__disable_interrupt();											// S荞݋֎~
		TIFR1 = 0xFF;													// /1S荞ݗv׸މ
		TIFR2 = 0xFF;													// /2S荞ݗv׸މ
		TCNT1H = 0;														// /1vl
		TCNT1L = 0;
		TCNT2 = 0;														// /2vl
		while (!(TIFR2 && (1<<OCF2A)));									// 32.768kHz200ۯ(OCR2Av)܂őҋ@
		TCCR1B = 0;														// /1v~
		__enable_interrupt();											// S荞݋
		if ((TIFR1 && (1<<TOV1)))										// /1 ް۰ȂA
		{
			temp = 0xFFFF;												// /1vlƂčőlݒ	[Bug:tempt̂-1ƂĈ]
		}
		else															// /1 ް۰ȂȂA
		{
			tempL = TCNT1L;												// /1vlʎ擾
			temp = TCNT1H;												// /1vlʎ擾
			temp = (temp << 8);											// 擾ʂ޲Ĉʒuֈړ
			temp += tempL;												// /1vl擾
		}
		if (temp > 6250)												// /1vlKzȂA
		{
			OSCCAL--;													// UZl
		}
		else if (temp < 6120)											// /1vlK艺ȂA
		{
			OSCCAL++;													// UZl
		}
		else															// /1vlK͈͓ȂA
			calibrate = TRUE;											// Z׸ސݒ
		TCCR1B = (1<<CS10);												// /1Ďn
	}
}

//*****************************************************************************
//*
//*	֐	: Delay
//*		: unsigned int millisec : 1msPʑҋ@l
//*	߂l	: Ȃ
//*	ړI	: 1msPʑҋ@
//*
//*****************************************************************************

void Delay(unsigned int millisec)
{
	int i;																// 1msҋ@vl

	while (millisec--)													// w莞ԑҋ@
		for (i=0; i<125; i++);											// 1msҋ@
}
